/*game.cxx
  Yury P. Fedorchenko 2005-2009
*/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "gm.h"
#include "game.h"

#define FIELD_SIZE 10

extern gm_field *first_field;
extern gm_field *second_field;

void machine_init()
{
  printf("machine\n");
  int size, direct, i, j, k, l, m, n, p, q;
  int place_free = 1;
  //trio

  for (size = 4; size > 0; size--) {
    for (l = 1; l < (6 - size); l++) {
      place_free = 1;
      direct = rand() % 2;
      i = rand() % (FIELD_SIZE - size);
      j = rand() % (FIELD_SIZE);
      if (direct) {
        for (k = 0; k < size; k++) {
          if (second_field->death[i + k][j] == 1)
            place_free = 0;
        }
        if (place_free) {
          for (k = 0; k < size; k++) {
            if (size > 1) {
              if (k == 0)
                second_field->ship[i + k][j] = 4; //nose 3,4
              else if (k == (size - 1))
                second_field->ship[i + k][j] = 8; //tail 7,8
              else
                second_field->ship[i + k][j] = 6; //middle  5,6
            } else
              second_field->ship[i + k][j] = size;
          }
        } else
          l -= 1;
      }                         //direct
      else {
        for (k = 0; k < size; k++) {
          if (second_field->death[j][i + k] == 1)
            place_free = 0;
        }
        if (place_free) {
          for (k = 0; k < size; k++) {
            if (size > 1) {
              if (k == 0)
                second_field->ship[j][i + k] = 3; //nose 3,4
              else if (k == (size - 1))
                second_field->ship[j][i + k] = 7; //tail 7,8
              else
                second_field->ship[j][i + k] = 5; //middle  5,6
            } else
              second_field->ship[j][i + k] = size;
          }
        } else
          l -= 1;
      }
      for (m = 0; m < FIELD_SIZE; m++)
        for (n = 0; n < FIELD_SIZE; n++)
          if (second_field->ship[m][n] != 0)
            for (p = m - 1; p < m + 2; p++)
              for (q = n - 1; q < n + 2; q++)
                if (p >= 0 && p < FIELD_SIZE && q >= 0 && q < FIELD_SIZE)
                  second_field->death[p][q] = 1;

    }
  }
  second_field->ship_size = 20;
}


int setfield(gm_field * fl, int x, int y, int size_put, int dir_put)
{
  int k, m, n, p, q, place_free;
  if (fl->ship[x][y] == 0 && fl->death[x][y] == 0) {
    place_free = 1;
    if ((dir_put == 1) && (x + size_put - 1) < FIELD_SIZE) {
      for (k = 0; k < size_put; k++) {
        if (fl->death[x + k][y] == 1)
          place_free = 0;
      }
      if (place_free == 1) {
        for (k = 0; k < size_put; k++) {
          fl->ship[x + k][y] = size_put;
          if (size_put > 1) {
            if (k == 0)
              fl->ship_dr[x + k][y] = 4;  //nose 3,4
            else if (k == (size_put - 1))
              fl->ship_dr[x + k][y] = 8;  //tail 7,8
            else
              fl->ship_dr[x + k][y] = 6;  //middle  5,6
          } else
            fl->ship_dr[x + k][y] = size_put;
          fl->ship_size++;
        }
      }
    } else if ((dir_put == 0) && (y + size_put - 1) < FIELD_SIZE) {
      for (k = 0; k < size_put; k++) {
        if (fl->death[x][y + k] == 1)
          place_free = 0;
      }
      if (place_free == 1) {
        for (k = 0; k < size_put; k++) {
          fl->ship[x][y + k] = size_put;
          if (size_put > 1) {
            if (k == 0)
              fl->ship_dr[x][y + k] = 3;  //nose 3,4
            else if (k == (size_put - 1))
              fl->ship_dr[x][y + k] = 7;  //tail 7,8
            else
              fl->ship_dr[x][y + k] = 5;  //middle  5,6
          } else
            fl->ship_dr[x][y + k] = size_put;
          fl->ship_size++;
        }
      }
    }
    for (m = 0; m < FIELD_SIZE; m++)
      for (n = 0; n < FIELD_SIZE; n++)
        if (fl->ship[m][n] != 0)
          for (p = m - 1; p < m + 2; p++)
            for (q = n - 1; q < n + 2; q++)
              if ((p >= 0 && p < FIELD_SIZE && q >= 0 && q < FIELD_SIZE))
                fl->death[p][q] = 1;

    if (place_free == 1)
      return 1;
  }
  return 0;
}


void init_battle()
{
  first_field->set_active(0);
  if (second_field->game_netstate == gm_field::AI) {
    srand(time(NULL));
    machine_init();
    second_field->type_ = 2;
  } else {
    second_field->type_ = 2;
    second_field->ship_size = 20;
  }
  second_field->set_active();
  first_field->undeath();
  second_field->undeath();
  first_field->draw();
  second_field->draw();
  status->handle(0,0,0);
}

void Battle(gm_field * fld)
{
  struct PTS {
    int x, y;
  } deriv[12] = { {
  1, 0}, {
  0, 1}, {
  -1, 0}, {
  0, -1}, {
  1, 0}, {
  0, 1}, {
  -1, 0}, {
  0, -1}, {
  1, 0}, {
  0, 1}, {
  -1, 0}, {
  0, -1}};
  static int outoffield;
  struct CELL {
    int x, y;
    int xf, yf;
    int size;
    int schet;
     CELL():size(0) {
    };
  };
  static CELL enemyshoot;

  int i, j, shoot;              //, plr=1;

  static int dd, dd1;

  shoot = 0;
  while (!shoot) {
    fld->draw();
/*    printf("sz %d x %d y %d xf %d yf %d sch %d\n",
		enemyshoot.size,
		enemyshoot.x,
		enemyshoot.y,
		enemyshoot.xf,
		enemyshoot.yf,
		enemyshoot.schet);*/
    // first hit
    if (enemyshoot.size == 0) {
//      printf("first\n");
      i = rand() % (FIELD_SIZE);
      j = rand() % (FIELD_SIZE);
      if (fld->shoot[i][j] != 1 && fld->death[i][j] != 1) {
        fld->shoot[i][j] = 1;
        if (fld->ship[i][j] != 0) {
          fld->ship_size--;
          if (fld->ship[i][j] == 1) {
            if (i > 0)
              fld->death[i - 1][j] = 1;
            if (j > 0)
              fld->death[i][j - 1] = 1;
            if (i < FIELD_SIZE - 1)
              fld->death[i + 1][j] = 1;
            if (j < FIELD_SIZE - 1)
              fld->death[i][j + 1] = 1;
          }
          enemyshoot.size = fld->ship[i][j] - 1;
          enemyshoot.x = i;
          enemyshoot.y = j;
          enemyshoot.xf = i;
          enemyshoot.yf = j;
          enemyshoot.schet = 0;
          dd = rand() % (4);
          fld->death_zone(i, j);
        } else {
          shoot = 1;
        }
      }
    } else {                    // additional hit
      i = enemyshoot.x + deriv[dd].x;
      j = enemyshoot.y + deriv[dd].y;
//      printf("second %d %d (%d,%d)",dd,dd1,i,j);
      outoffield = 0;
      if ((i < FIELD_SIZE && i >= 0) && (j < FIELD_SIZE && j >= 0)) {
        if (fld->shoot[i][j] != 1 && fld->death[i][j] != 1) {
          fld->shoot[i][j] = 1;
          if (fld->ship[i][j] != 0) {
            fld->ship_size--;
            enemyshoot.size--;
            enemyshoot.x = i;
            enemyshoot.y = j;
            dd1 = dd;
            enemyshoot.schet++;

            if (enemyshoot.size == 0) {
              int f = i + deriv[dd].x;
              int d = j + deriv[dd].y;
              if ((f >= 0 && f < FIELD_SIZE) && (d >= 0 && d < FIELD_SIZE)) {
                fld->death[f][d] = 1;
              }
            }
            outoffield = 1;
            fld->death_zone(i, j);
          } else {              //not a ship
            shoot = 1;
            if (enemyshoot.schet == 0) {
              dd++;
            } else {
              dd += 2;
              enemyshoot.x = enemyshoot.xf;
              enemyshoot.y = enemyshoot.yf;
            }
            //        plr = 0;
            outoffield = 1;
            enemyshoot.schet = 0;
          }
        } else if (fld->ship[i][j] != 0) {
          outoffield = 1;
          dd++;
        }
      }
      if (outoffield == 0) {
        if (enemyshoot.schet == 0) {
          dd++;
        } else if (enemyshoot.size == 0) {

        } else {
          enemyshoot.x = enemyshoot.xf;
          enemyshoot.y = enemyshoot.yf;
          dd = dd1 + 2;
        }
      }
      if (dd > 11)
        dd -= 12;
      //if(dd1>11)dd1-=11;
    }                           //else
  }
}
