/*gm.cxx
  Yury P. Fedorchenko 2005-2009
*/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "gm.h"
#include "game.h"

#include "inkview.h"

#include "images/dth.xpm.h"
#include "images/flmanowar.xpm.h"
#include "images/mid_v.xpm.h"
#include "images/mid.xpm.h"
#include "images/nos_v.xpm.h"
#include "images/nos.xpm.h"
#include "images/ship.xpm.h"
#include "images/shootd.xpm.h"
#include "images/shoot.xpm.h"
#include "images/tail_v.xpm.h"
#include "images/tail.xpm.h"


int i16col(int i){return i*0x111111;}


int dir_put;

void gm_field::draw()
{
  //printf("field %d\n",type());
  for (int i = 0; i < 10; i++)
    for (int j = 0; j < 10; j++) {
      if(ship_dr[i][j]!=0)printf("ship_dr[i][j] %d (%d,%d) %d\n",ship_dr[i][j],f_x[i][j], f_y[i][j] , field_size);
      switch (ship_dr[i][j]) {
      case 0:
        DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,BLACK);
        break;
      case 1:
        if (type() == 1)
          DrawBitmap(f_x[i][j], f_y[i][j],&::ship);
        else
          DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,i16col(1));
        break;
      case 3:
        if (type() == 1)
          DrawBitmap(f_x[i][j], f_y[i][j], &::nos_v);
        else
          DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,i16col(3));
        break;
      case 4:
        if (type() == 1)
          DrawBitmap(f_x[i][j], f_y[i][j], &::nos);
        else
          DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,i16col(4));
        break;
      case 5:
        if (type() == 1)
          DrawBitmap(f_x[i][j], f_y[i][j], &::mid_v);
        else
          DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,i16col(5));
        break;
      case 6:
        if (type() == 1)
          DrawBitmap(f_x[i][j], f_y[i][j], &::mid);
        else
          DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,i16col(6));
        break;
      case 7:
        if (type() == 1)
          DrawBitmap(f_x[i][j], f_y[i][j], &::tail_v);
        else
          DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,i16col(7));
        break;
      case 8:
        if (type() == 1)
          DrawBitmap(f_x[i][j], f_y[i][j], &::tail);
        else
          DrawRect(f_x[i][j], f_y[i][j], field_size, field_size,i16col(8));
        break;
      }                         //switch
      if (shoot[i][j] == 1) {
        //status->msg("%d %d\n",shoot[i][j],ship[i][j]);
        if (ship[i][j] == 0)
          DrawBitmap(f_x[i][j], f_y[i][j],&::shootd);
        else
          DrawBitmap(f_x[i][j], f_y[i][j],&::shoot);
      } else if (level == 1)
        if (death[i][j] != 0 && ship_dr[i][j] == 0)
          DrawBitmap(f_x[i][j], f_y[i][j],&::dth);
    }                           //for
}

int gm_field::handle(int e,int x,int y)
{
  if (active()) {
    struct pnt a;
    a.x = x;
    a.y = y;
    printf("handle %d ! %d %d (%d)\n",active(),a.x,a.y,death[a.x][a.y]);
    if (index(a) == 0) {
      printf("index ok %d %d (%d)\n",a.x,a.y,type());
      if (type() == 1) {
        printf("beforeput %d %d (%d)ss %d\n",a.x,a.y,death[a.x][a.y],ship_size);
        if (death[a.x][a.y] != 1) {
          if (setfield(this, a.x, a.y, (ship_size < 4) ? 4 : (ship_size < 10) ? 3 : (ship_size < 16) ? 2 : 1, dir_put)){
            printf("put suxxess %d\n",ship_size);
            if (ship_size >= 20){
              init_battle();
              status->msg(_("Begin battle!"));
            }
          }
        }//else status->msg("death here\n");
      } else if (gm_field::AI == game_netstate && type() == 2) {
        if (ship_size == 0 || first_field->ship_size == 0)
          return 0;
        if (shoot[a.x][a.y] != 1) {
          shoot[a.x][a.y] = 1;
          if (ship[a.x][a.y] != 0) {
            death_zone(a.x, a.y);
            ship_size--;
            status->msg(_("Hit!\n"));
          } else {
            status->msg(_("Miss!\n"));
            Battle(first_field);
          }
          if (ship_size == 0 || first_field->ship_size == 0)
            status->msg(_("game over %s\n"), (first_field->ship_size == 0) ? _("You Lose!") : _("You Win!") );
        }
      }
      return 0;
    }
  }
  return 0;
}

void gm_field::initialize()
{
  dir_put = 1;
  ship_size = 0;
  field_size = 300 / 10;
  int beg1=ScreenWidth()/2-310,beg2=ScreenWidth()/2+10;
  for (int i = 0; i < 10; ++i)
    for (int j = 0; j < 10; ++j) {
      f_x[i][j] = ((type()==1)?beg1:beg2) + i * field_size;
      f_y[i][j] = 10 + j * field_size;
      ship[i][j] = 0;
      ship_dr[i][j] = 0;
      shoot[i][j] = 0;
      death[i][j] = 0;
    }
}

int gm_field::hit(int i, int j)
{
  if (shoot[i][j] == 0) {
    if (ship[i][j] != 0)
      return ship[i][j];
    else
      return 0;
  } else {
    return -1;
  }
  return 0;
}

int gm_field::index(struct pnt &a)
{
  for (int i = 0; i < 10; ++i)
    for (int j = 0; j < 10; ++j) {
      if (f_x[i][j] < a.x && a.x < (f_x[i][j] + field_size) 
       && f_y[i][j] < a.y && a.y < (f_y[i][j] + field_size)) {
        a.x = i;
        a.y = j;
        return 0;
      }
    }
  return -1;
}

void gm_field::death_zone(int i, int j)
{
  int k, l;
  k = i - 1;
  if (k >= 0) {
    l = j - 1;
    if (l >= 0)
      death[k][l] = 1;
    l = j + 1;
    if (l < FIELD_SIZE)
      death[k][l] = 1;
  }
  k = i + 1;
  if (k < FIELD_SIZE) {
    l = j - 1;
    if (l >= 0)
      death[k][l] = 1;
    l = j + 1;
    if (l < FIELD_SIZE)
      death[k][l] = 1;
  }
}
ifont * mfont=NULL;
void status_field::draw(){
  if(!mfont){
    mfont = OpenFont(DEFAULTFONT,20,0);
  }
  SetFont(mfont,BLACK);
  FillArea(0,320,ScreenWidth(), ScreenHeight()-320, LGRAY);
  DrawTextRect(0,320,ScreenWidth(), ScreenHeight()-320,str,0);
  PartialUpdate(0,320,ScreenWidth(), ScreenHeight()-320);
}
int status_field::handle(int,int x,int y){
  if(first_field->active()){
    if(y>320){
      dir_put=!dir_put;
    }
    msg(_("Direction :%s . Ship size is %d"),(dir_put==1)?_("Horizontal"):_("Vertical"),
      (first_field->ship_size < 4) ? 4 : (first_field->ship_size < 10) ? 3 : (first_field->ship_size < 16) ? 2 : 1);
  }
  return 0;
}
#include <stdarg.h>
void status_field::msg(const char*fmt,...){
   va_list lst;
   va_start(lst,fmt);
   vsprintf(str,fmt,lst);
   va_end(lst);
   draw();
}
//end Death
