#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <sys/ioctl.h>
#include <sys/mount.h>
#include <dlfcn.h>
#include "inkview.h"

#include "gm.h"
#include "game.h"
#include "nls.h"

gm_field* first_field = (gm_field*)0;
gm_field* second_field = (gm_field*)0;
status_field* status;

//extern const ibitmap mine00,mine01,mine02,mine03,mine04,mine05,mine06,mine07,mine08,minecl,minefl,mbomb,mcursor;

int main_handler(int, int, int);
void menu1_handler(int index);
int cindex=0;

static imenu menu1[] = {

	{ ITEM_HEADER,   0, "Menu", NULL },
	{ ITEM_ACTIVE, 101, "New Game", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 103, "Help", NULL },
	{ ITEM_ACTIVE, 102, "About", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 121, "Exit", NULL },
	{ 0, 0, NULL, NULL }

};

void dialog_exit_handler(int button) {
  if(1 == button)CloseApp();
}

int set_field_handler(int type, int par1, int par2)
{
  if (type == EVT_INIT) {
    ClearScreen();
  }
  if ( EVT_SHOW == type ){
    //msg("EVT_SHOW");
    //ClearScreen();
    first_field->draw();
    second_field->draw();
    FullUpdate();
  }
  if (type == EVT_KEYPRESS) {
    switch (par1) {
       case KEY_MENU:
       case KEY_BACK:
       OpenMenu(menu1, cindex, 20, 20, menu1_handler);
       break;
    }
  }
  if (type == EVT_POINTERUP){
    printf("pointerup\n");
#ifndef __EMU__
    first_field->handle(type,par1,par2);
    second_field->handle(type,par1,par2);
    status->handle(type,par1,par2);
#else
    first_field->handle(type,par2,600-par1);
    second_field->handle(type,par2,600-par1);
    status->handle(type,par2,600-par1);
#endif
    first_field->draw();
    second_field->draw();
    SoftUpdate();
  }
  return 0;
}


void menu1_handler(int index) {
  cindex=index;
	int i;
	switch (index) {
	case 101:
	ClearScreen();
	first_field->initialize();
	second_field->initialize();
	first_field->set_active(1);
	second_field->game_netstate=gm_field::AI;
	status->msg("Place ships.");
	status->handle(0,0,0);
      SetEventHandler(set_field_handler);
	break;
	case 102:
	Message(ICON_INFORMATION, "About", _("pbManowar v 0.5. Classic battle ship game\n"
	"Yury P. Fedorchenko 2011. PocketBook port\n"
        "This is free sowtware and distributed under terms\n of"
        "GNU GPL License\n"
        "www.fedorchenko.net"), 10000);
	break;
	case 103:
		Message(ICON_INFORMATION, "Help", "This is Classic Battle ship game\n"
        "See Rules of flmanowar Game at"
        "www.fedorchenko.net", 10000);
	break;
	case 121:
	Dialog(ICON_QUESTION, "Quit", "Quit game?", "Yes", "No", dialog_exit_handler);
	break;
  }
}


int main_handler(int type, int par1, int par2)
{
//fprintf(stderr, "[%i %i %i]\n", type, par1, par2);

  if (type == EVT_INIT) {
    ClearScreen();
    SetOrientation(1);
    //machine_init();
  }

  if (type == EVT_SHOW) {
    first_field->draw();
    second_field->draw();
    FullUpdate();
  }

  if (type == EVT_KEYPRESS) {
    switch (par1) {
      case KEY_OK:
        //msg("KEY_OK");
        OpenMenu(menu1, cindex, 20, 20, menu1_handler);
      break;

			case KEY_BACK:
				//msg("KEY_BACK");
				CloseApp();
				break;

			case KEY_LEFT:
				//msg("KEY_LEFT");
				break;

			case KEY_RIGHT:
				//msg("KEY_RIGHT");
				break;

			case KEY_UP:
				//msg("KEY_UP");
				break;

			case KEY_DOWN:
				//msg("KEY_DOWN");
				break;

			case KEY_MUSIC:
				//msg("KEY_MUSIC");
				break;

			case KEY_MENU:
				//msg("KEY_MENU");
				break;

			case KEY_DELETE:
				//msg("KEY_DELETE");
				break;

		}
	}
	if (type == EVT_EXIT) {
		// occurs only in main handler when exiting or when SIGINT received.
		// save configuration here, if needed
	}

	return 0;
}

int main(int argc, char **argv)
{
  OpenScreen();
  SetOrientation(1);
  first_field = new gm_field(1);
  second_field = new gm_field(0);
  status = new status_field();
  InkViewMain(main_handler);
  return 0;
}

